; Keymaker - Transsoft Transport and Software Fact 1.5
; ==============================================================================
; Author : Canter <canterwood@altern.org>
; Website: http://zor.org/canterwood
; IDE    : MASM32 8
; ==============================================================================
; v1.0

; Libs used
include    \masm32\include\comdlg32.inc
includelib \masm32\lib\comdlg32.lib

; Functions
Initialize PROTO : HWND
CheckName  PROTO : LPCTSTR
Generate   PROTO : HWND
QuickCopy  PROTO : HWND

.data

; Parameters (defined)
; ------------------------------------------------------------------------------

; Required data
sTitle      TCHAR "Transsoft Transport and Software Fact 1.5 keymaker", 0
sAuthor     TCHAR "Canter [NGEN]", 0
sInfo       TCHAR "Protection: Standard (Visual Basic)", 10, 13
            TCHAR 10, 13
            TCHAR "Thanks to: +Analyst, Iczelion, ShmeitCorp, Lise_Grim, +Christal, NGEN", 10, 13
            TCHAR 10, 13
            TCHAR "Greetings fly out to: ICI (RIP), FFF, RIF and all those who are listed using the #Ran function of this keymaker...", 10, 13
            TCHAR 10, 13
            TCHAR "Music: Ghidorah - Toilet Story", 0
            
sNameError  TCHAR "Invalid name size.", 0
sMakeOK     TCHAR "The serial has been copied into the clipboard.", 0

; Defined-variables
msFilter     TCHAR "Fact 1.5 (Fact 1.5.exe)", 0, "Fact 1.5.exe", 0, 0
sKeyfileName TCHAR "\code.tsf", 0

; ------------------------------------------------------------------------------

.data?

; Parameters (undefined)
; ------------------------------------------------------------------------------

; Required data
sName   CHAR 15  dup(?)
sSerial CHAR 60h dup(?)

; Undefined-variables
ofn           OPENFILENAME <?>
sAppPath      TCHAR        MAX_PATH dup(?)
sKeyfilePath  TCHAR        MAX_PATH dup(?)
sKeyfile      TCHAR        100h dup(?)
hKeyfile      HANDLE       ?
nBytesWritten DWORD        ?
; ------------------------------------------------------------------------------

.code

; Initialization
; ------------------------------------------------------------------------------
Initialize PROC hWnd: HWND

  ; Set the limit for the name text field
  INVOKE SendDlgItemMessage, hWnd, IDC_NAME, EM_SETLIMITTEXT, SIZEOF sName - 1, 0

  INVOKE SetDlgItemText, hWnd, IDC_NAME, ADDR sAuthor
  INVOKE Generate, hWnd
  ret
Initialize ENDP
; ------------------------------------------------------------------------------

; I. Name-checking
; Input : pName
; Output: name length or 0 (failure)
; ------------------------------------------------------------------------------
CheckName PROC pName: LPCTSTR
  INVOKE lstrlen, pName

  .IF eax < 5 || eax > 14
    xor eax, eax
  .ENDIF

  ret
CheckName ENDP
; ------------------------------------------------------------------------------

; II. Serial-generation
; ------------------------------------------------------------------------------
Generate PROC USES ebx esi edi hWnd: HWND
  LOCAL p3:DWORD
  LOCAL p4:DWORD

  INVOKE GetDlgItemText, hWnd, IDC_NAME, ADDR sName, SIZEOF sName
  INVOKE CheckName, ADDR sName
  test eax, eax
  je @@validityerror

  mov ebx, eax

  ; Generation routine
  lea esi, sName
  xor ecx, ecx
  xor edx, edx

  sum:
  movzx eax, byte ptr[sName+ecx]
  cmp eax, 0
  je endsum
  add edx, eax
  inc ecx
  jmp sum

  endsum:
  mov p3, edx

  mov ecx, ebx
  add ecx, 59h
  mov p4, ecx

  mov eax, edx
  mov edx, 100
  mul edx

  ; Bug fix (name > 10 chars)
  .IF p4 >= 100
    mov edx, 10
    mul edx
  .ENDIF

  add eax, ecx
  add eax, p3

  mov ecx, ebx
  add ecx, 0Ah

  INVOKE wsprintf, ADDR sSerial, SADD(" %d%d %d %d %d"), ecx, eax, ecx, p3, p4

  INVOKE SetDlgItemText, hWnd, IDC_SERIAL, ADDR sSerial
  jmp @@endgenerate

  @@validityerror:
  INVOKE SetDlgItemText, hWnd, IDC_SERIAL, ADDR sNameError

  @@endgenerate:
  ret
Generate ENDP
; ------------------------------------------------------------------------------

; III. Quick Copy
; ------------------------------------------------------------------------------
QuickCopy PROC hWnd: HWND
  mov ofn.lStructSize, SIZEOF ofn
  push hWnd
  pop ofn.hwndOwner
  mov ofn.lpstrFilter, OFFSET msFilter
  INVOKE lstrcpy, ADDR sAppPath, SADD("Fact 1.5.exe")
  mov ofn.lpstrFile, OFFSET sAppPath
  mov ofn.nMaxFile, SIZEOF sAppPath
  mov ofn.lpstrTitle, CTXT("Select the target application")
  mov ofn.Flags, OFN_FILEMUSTEXIST or OFN_HIDEREADONLY

  INVOKE GetOpenFileName, ADDR ofn

  .IF eax
    movzx eax, ofn.nFileOffset
    INVOKE lstrcpyn, ADDR sKeyfilePath, ADDR sAppPath, eax
    INVOKE lstrcat, ADDR sKeyfilePath, ADDR sKeyfileName

    INVOKE CreateFile, ADDR sKeyfilePath, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL

    .IF eax != INVALID_HANDLE_VALUE
      mov hKeyfile,eax

      INVOKE lstrcpy, ADDR sKeyfile, ADDR sSerial
      INVOKE lstrcat, ADDR sKeyfile, ADDR sCRLF
      INVOKE lstrcat, ADDR sKeyfile, ADDR sName
      INVOKE lstrlen, ADDR sKeyfile

      INVOKE WriteFile, hKeyfile, ADDR sKeyfile, eax, ADDR nBytesWritten, NULL

      INVOKE CloseHandle, hKeyfile

      INVOKE SetDlgItemText, hWnd, IDC_SERIAL, SADD("Keyfile successfully created.")
    .ELSE
      INVOKE SetDlgItemText, hWnd, IDC_SERIAL, SADD("Error: Please copy manually your reg info.")
    .ENDIF
    
  .ENDIF

  ret
QuickCopy ENDP
; ------------------------------------------------------------------------------